//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)        
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Channels;
//
using RKiss.WSEventing;
#endregion


namespace RKiss.WSEventing.Adapters
{
    #region PublisherBase
    public abstract class PublisherBase
    {
        #region Properties
        HybridDictionary _properties;
        public HybridDictionary Properties
        {
            get { return _properties; }
        }
        #endregion

        #region Constructors
        protected PublisherBase()
            : this(null)
        {
        }
        protected PublisherBase(HybridDictionary properties)
        {
            _properties = properties;
        }
        #endregion

        public void DeliveryMessage(object state)
        {
            FireState firestate = state as FireState;
            if (firestate != null)
            {
                OnDeliveryMessage(firestate.Message, firestate.Subscription);
            }
        }

        public virtual void OnDeliveryMessage(Message message, Subscription subscription)
        {
        }
    }
    #endregion
}
