//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)        
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{
    #region GetStatus
    [MessageContract]
    [XmlSchemaProvider(null, IsAny = true)]
    public class GetStatus : IXmlSerializable
    {
        #region Constructors
        public GetStatus()
        {
        }
        public GetStatus(GetStatus status)
        {
            this.Copy(status);
        }
        public void Copy(GetStatus status)
        {
        }
        #endregion

        #region IXmlSerializable Members
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }
        public void ReadXml(XmlReader reader)
        {
            reader.ReadStartElement(WSEventing.ElementNames.GetStatus, WSEventing.NamespaceUri);
            reader.ReadEndElement();
        }
        public void WriteXml(XmlWriter writer)
        {
            writer.WriteStartElement(WSEventing.NamespacePrefix, WSEventing.ElementNames.GetStatus, WSEventing.NamespaceUri);
            writer.WriteEndElement();
        }
        #endregion
    }
    #endregion

    #region GetStatusResult
    [MessageContract]
    [XmlSchemaProvider(null, IsAny = true)]
    public class GetStatusResult : IXmlSerializable
    {
        #region Properties
        Expires _expires;
        public Expires Expires
        {
            get { return _expires; }
            set { _expires = value; }
        }
        #endregion

        #region Constructors
        public GetStatusResult()
        {
        }
        public GetStatusResult(GetStatusResult result)
        {
        }
        public GetStatusResult(Expires expires)
        {
            Expires = expires;
        }
        public void Copy(GetStatusResult result)
        {
            if (result != null)
            {
                this.Expires = result.Expires;
            }
        }
        #endregion

        #region IXmlSerializable Members
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }
        public void ReadXml(XmlReader reader)
        {
            reader.ReadStartElement(WSEventing.ElementNames.GetStatusResponse, WSEventing.NamespaceUri);
            Expires = new Expires(reader);
            reader.ReadEndElement();
        }
        public void WriteXml(XmlWriter writer)
        {
            if (Expires == null)
                throw new NullReferenceException("Expires");

            writer.WriteStartElement(WSEventing.NamespacePrefix, WSEventing.ElementNames.GetStatusResponse, WSEventing.NamespaceUri);
            Expires.WriteXml(writer);
            writer.WriteEndElement();
        }
        #endregion
    }
    #endregion
}

