//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)     
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{
    #region MessageContract
    #region GetStatusRequest
    /// <summary>
    /// WS-Eventing GetStatus request message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class GetStatusRequest : GetStatus
    {
        #region DataMembers
        private Identifier _identifier;
        #endregion

        #region Properties
        [MessageHeader(Name = WSEventing.ElementNames.Identifier, Namespace = WSEventing.NamespaceUri)]
        public Identifier Identifier
        {
            get { return _identifier; }
            set { _identifier = value; }
        }
        [MessageBodyMember(Name = WSEventing.ElementNames.GetStatus, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public GetStatus Body
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public GetStatusRequest()
        {
            Identifier = new Identifier();
        }
        public GetStatusRequest(Identifier id)
        {
            Identifier = id;
        }
        public GetStatusRequest(Identifier id, GetStatus status)
        {
            Identifier = id;
            Body = status;
        }
        #endregion
    }
    #endregion

    #region GetStatusResponse
    /// <summary>
    /// WS-Eventing GetStatus response message class
    /// </summary>
    [MessageContract(IsWrapped = false)]//(Action = WSEventing.GetStatusResponseAction)]
    public class GetStatusResponse : GetStatusResult
    {
        #region Properties
        [MessageBodyMember(Name = WSEventing.ElementNames.GetStatusResponse, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public GetStatusResult Body
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public GetStatusResponse()
        {
        }
        public GetStatusResponse(GetStatusResult result)
        {
            Body = result;
        }
        #endregion
    }
    #endregion
    #endregion
}

