//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)         
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.Runtime.Serialization;
#endregion

namespace RKiss.WSEventing
{

    [ServiceContract(Namespace = WSEventing.NamespaceUri)]
    [XmlSerializerFormat(Style = OperationFormatStyle.Document)] 
    public interface IWSEventing : IWSEventingFactory, IWSEventingOperation
    {
    }
    
    [ServiceContract(Namespace = WSEventing.NamespaceUri)]
    [XmlSerializerFormat(Style = OperationFormatStyle.Document)]   
    public interface IWSEventingFactory
    {
        [OperationContract(Action = WSEventing.SubscribeAction, ReplyAction = WSEventing.SubscribeResponseAction)]
        [FaultContract(typeof(SupportedDeliveryMode))]
        [FaultContract(typeof(SupportedDialect))]
        [TransactionFlow(TransactionFlowOption.Allowed)]
        SubscribeResponse Subscribe(SubscribeRequest request);
    }

    [ServiceContract(Namespace = WSEventing.NamespaceUri)]
    [XmlSerializerFormat(Style = OperationFormatStyle.Document)]
    public interface IWSEventingOperation
    {
        [OperationContract(Action = WSEventing.GetStatusAction, ReplyAction = WSEventing.GetStatusResponseAction)]
        [TransactionFlow(TransactionFlowOption.Allowed)]
        GetStatusResponse GetStatus(GetStatusRequest request);

        [OperationContract(Action = WSEventing.RenewAction, ReplyAction = WSEventing.RenewResponseAction)]
        [TransactionFlow(TransactionFlowOption.Allowed)]
        RenewResponse Renew(RenewRequest request);

        [OperationContract(Action = WSEventing.UnsubscribeAction, ReplyAction = WSEventing.UnsubscribeResponseAction)]
        [TransactionFlow(TransactionFlowOption.Allowed)]
        UnsubscribeResponse Unsubscribe(UnsubscribeRequest request);

    }
}
