//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)    
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{
    #region Renew
    [MessageContract]
    [XmlSchemaProvider(null, IsAny = true)]
    public class Renew : IXmlSerializable
    {
        #region Properties
        Expires _expires;
        public Expires Expires
        {
            get { return _expires; }
            set { _expires = value; }
        }
        #endregion

        #region Constructors
        public Renew()
        {
        }
        public Renew(Renew renew)
        {
            this.Copy(renew);
        }
        public Renew(Expires expires)
        {
            Expires = expires;
        }
        public void Copy(Renew renew)
        {
            if (renew != null)
            {
                this.Expires = renew.Expires;
            }
        }
        #endregion

        #region IXmlSerializable Members
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }
        public void ReadXml(XmlReader reader)
        {
            reader.ReadStartElement(WSEventing.ElementNames.Renew, WSEventing.NamespaceUri);
            Expires = new Expires(reader);
            reader.ReadEndElement();
        }
        public void WriteXml(XmlWriter writer)
        {
            if (Expires == null)
                throw new NullReferenceException("Expires");
 
            writer.WriteStartElement(WSEventing.NamespacePrefix, WSEventing.ElementNames.Renew, WSEventing.NamespaceUri);
            Expires.WriteXml(writer);               
            writer.WriteEndElement();
        }
        #endregion
    }
    #endregion

    #region RenewResult
    [MessageContract]
    [XmlSchemaProvider(null, IsAny = true)]
    public class RenewResult : IXmlSerializable
    {
        #region Properties
        Expires _expires;
        public Expires Expires
        {
            get { return _expires; }
            set { _expires = value; }
        }
        #endregion

        #region Constructors
        public RenewResult()
        {
        }
        public RenewResult(RenewResult result)
        {
            this.Copy(result);
        }
        public RenewResult(Expires expires)
        {
            Expires = expires;
        }
        public void Copy(RenewResult result)
        {
            if (result != null)
            {
                this.Expires = result.Expires;
            }
        }
        #endregion

        #region IXmlSerializable Members
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }
        public void ReadXml(XmlReader reader)
        {
            reader.ReadStartElement(WSEventing.ElementNames.RenewResponse, WSEventing.NamespaceUri);
            Expires = new Expires(reader);
            reader.ReadEndElement();
        }
        public void WriteXml(XmlWriter writer)
        {
            if (Expires == null)
                throw new NullReferenceException("Expires");

            writer.WriteStartElement(WSEventing.NamespacePrefix, WSEventing.ElementNames.RenewResponse, WSEventing.NamespaceUri);
            Expires.WriteXml(writer);
            writer.WriteEndElement();
        }
        #endregion
    }
    #endregion
    
}
