//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)      
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{
    #region RenewRequest
    /// <summary>
    /// WS-Eventing Renew request message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class RenewRequest : Renew
    {
        #region DataMembers
        private Identifier _identifier;
        #endregion

        #region Properties
        [MessageHeader]
        public Identifier Identifier
        {
            get { return _identifier; }
            set { _identifier = value; }
        }
        [MessageBodyMember(Name = WSEventing.ElementNames.Renew, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public Renew Body
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public RenewRequest()
        {
            Identifier = new Identifier();
        }
        public RenewRequest(Identifier id, Renew renew)
        {
            Identifier = id;
            Body = renew;
        }
        #endregion
    }
    #endregion

    #region RenewResponse
    /// <summary>
    /// WS-Eventing Renew response message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class RenewResponse : RenewResult
    {
        #region Properties
        [MessageBodyMember(Name = WSEventing.ElementNames.RenewResponse, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public RenewResult Body
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public RenewResponse()
        {
        }
        public RenewResponse(RenewResult result)
        {
            Body = result;
        }
        #endregion
    }
    #endregion
}
