//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)      
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{
    #region SubscribeRequest
    /// <summary>
    /// WS-Eventing Subscribe request message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class SubscribeRequest : Subscribe
    {
        #region DataMembers
        private string _subscriptionTopic;
        #endregion

        // option: 
        [MessageHeader(Name = WSEventing.Extension.SubscriptionTopic, Namespace = WSEventing.Extension.NamespaceUri)]
        public string SubscriptionTopic
        {
            get { return _subscriptionTopic; }
            set { _subscriptionTopic = value; }
        }

        #region Properties
        [MessageBodyMember(Name = WSEventing.ElementNames.Subscribe, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public Subscribe Body   
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public SubscribeRequest()
        {
        }
        public SubscribeRequest(Subscribe subscribe)
        {
            Body = subscribe;
        }
        #endregion
    }
    #endregion


    #region SubscribeResponse
    /// <summary>
    /// WS-Eventing Subscribe response message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class SubscribeResponse : SubscribeResult
    {
        #region Properties
        [MessageBodyMember(Name = WSEventing.ElementNames.SubscribeResponse, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public SubscribeResult Body
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public SubscribeResponse()
        {
        }
        public SubscribeResponse(SubscribeResult result)
        {
            Body = result;
        }
        #endregion
    }
    #endregion
}