//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)        
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{

    [XmlSchemaProvider(null, IsAny = true)]
    public class SubscriptionManager : IXmlSerializable
    {
        #region DataMembers
        EndpointAddress _epa;
        #endregion

        #region Properties
        public EndpointAddress EndpointAddress
        {
            get { return _epa; }
            set { _epa = value; }
        }
        public Identifier Identifier
        {
            get { return new Identifier(EndpointAddress); }
        }
        #endregion

        #region Constructors
        public SubscriptionManager()
        {
        }
        public SubscriptionManager(Uri address, Identifier id)
        {
            EndpointAddress = new EndpointAddress(address, new AddressHeader[] { id.AddressHeader });
        }
        public SubscriptionManager(Uri address, AddressHeader[] headers)
        {
            EndpointAddress = new EndpointAddress(address, headers);
        }
        public SubscriptionManager(XmlReader reader)
        {
            this.ReadXml(reader);
        }
        #endregion

        #region IXmlSerializable Members
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }
        public void ReadXml(XmlReader reader)
        {
            EndpointAddress = EndpointAddress.ReadFrom(AddressingVersion.WSAddressing10, reader, WSEventing.ElementNames.SubscriptionManager, WSEventing.NamespaceUri);
        }
        public void WriteXml(XmlWriter writer)
        {
            if (EndpointAddress != null)
            {
                EndpointAddress.WriteTo(AddressingVersion.WSAddressing10, writer, WSEventing.ElementNames.SubscriptionManager, WSEventing.NamespaceUri);
            }
        }
        #endregion
    }   
}