//*****************************************************************************
//    Description.....WS-Eventing for WCF
//                                
//    Author..........Roman Kiss, rkiss@pathcom.com
//    Copyright  2005 ATZ Consulting Inc. (see included license.rtf file)       
//                        
//    Date Created:    06/06/06
//
//    Date        Modified By     Description
//-----------------------------------------------------------------------------
//    06/06/06    Roman Kiss     Initial Revision
//    07/07/06    Roman Kiss     Version JuneCTP 2006
//    11/11/06    Roman Kiss     RTM
//*****************************************************************************
//  
#region References
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.ServiceModel;
using System.Runtime.Serialization;
#endregion


namespace RKiss.WSEventing
{
    #region UnsubscribeRequest
    /// <summary>
    /// WS-Eventing Unsubscribe request message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class UnsubscribeRequest : Unsubscribe
    {
        #region DataMembers
        private Identifier _identifier;
        #endregion

        #region Properties
        [MessageHeader]//(Name = WSEventing.ElementNames.Identifier, Namespace = WSEventing.NamespaceUri)]
        public Identifier Identifier
        {
            get { return _identifier; }
            set { _identifier = value; }
        }

        [MessageBodyMember(Name = WSEventing.ElementNames.Unsubscribe, Namespace = WSEventing.NamespaceUri, Order = 0)]
        public Unsubscribe Body
        {
            get { return this; }
            set { this.Copy(value); }
        }
        #endregion

        #region Constructors
        public UnsubscribeRequest()
        {
        }
        public UnsubscribeRequest(Identifier id)
        {
            Identifier = id;
        }
        public UnsubscribeRequest(Identifier id, Unsubscribe unsubcribe)
        {
            Identifier = id;
            Body = unsubcribe;
        }
        #endregion
    }
    #endregion

    #region UnsubscribeResponse
    /// <summary>
    /// WS-Eventing Unsubscribe response message class
    /// </summary>
    [MessageContract(IsWrapped = false)]
    public class UnsubscribeResponse
    {
        #region Constructors
        public UnsubscribeResponse()
        {
        }
        #endregion
    }
    #endregion
}


