using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using Messages.WS.Eventing;

namespace SendingServer
{
    public class SendingServer
    {
        static ChannelFactory<IMessageSending> channelNotification;

        /*
            Closes the connection between each message being sent.
         */
        public void SendMessage(MessageTransferRequest message)
        {
            using (ChannelFactory<IMessageSending> channelNotification2 = new ChannelFactory<IMessageSending>("Notify"))
            {
                channelNotification2.Open();
                IMessageSending manager = channelNotification2.CreateChannel();
                manager.SendMessage(message);
                channelNotification2.Close();
            }
        }

        
          /* Use this when sending messages with SendMessageOpenConnection*/
        
        public SendingServer(){

            channelNotification = new ChannelFactory<IMessageSending>("Notify");
            channelNotification.Open();
        }

        /*
            Does not close the connection between each message being sent.
         */
        public void SendMessageOpenConnection(MessageTransferRequest message)
        {            
            IMessageSending manager = channelNotification.CreateChannel();     
            manager.SendMessage(message);           
        }
    }
}
