using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.Xml;


namespace Messages.WS.Eventing
{
    [XmlSchemaProvider(null, IsAny = true)]
    public class MessageContents : IXmlSerializable
    {
        string _namespace = "http://www.example.org/test";
        DateTime _datetime;
        string _message_id = "-1";
        string[] _payload;
        int _contentLength;
        static int numberOfStrings;

        public DateTime DateTime { get { return _datetime; } set { _datetime = value; } }
        public string MessageId { get { return _message_id; } set { _message_id = value; } }
        public int ContentLength { get { return _contentLength; } set { _contentLength = value; } }
        public string[] Payload{
            get 
            { return _payload; } 
            set 
            { _payload = value; } }
        
        public MessageContents() { }

        #region IXmlSerializable Members
        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }
        public void ReadXml(XmlReader reader)
        {
            reader.ReadStartElement("MessageContents", _namespace);
            DateTime = reader.ReadElementContentAsDateTime("DateTime", _namespace);
            MessageId = reader.ReadElementString("MessageId", _namespace);
            ContentLength = reader.ReadElementContentAsInt("ContentLength", _namespace);
            _payload = new String[ContentLength];
            for(int i = 0; i < ContentLength; i++)
            {
                _payload[i] = reader.ReadElementContentAsString("Payload" + i, _namespace);
            }
            reader.Skip();
            reader.ReadEndElement();
        }
        public void WriteXml(XmlWriter writer)
        {
            writer.WriteStartElement("mc", "MessageContents", _namespace);
            writer.WriteElementString("DateTime", _namespace, XmlConvert.ToString(DateTime, XmlDateTimeSerializationMode.Utc));
            writer.WriteElementString("MessageId", _namespace, MessageId);
            ContentLength = Payload.Length;
            writer.WriteElementString("ContentLength", _namespace, ""+numberOfStrings);
            for (int i = 0; i < numberOfStrings; i++)
            {
                writer.WriteElementString("Payload"+i, _namespace, Payload[i]);
            }            
            writer.WriteEndElement();
        }
        public static String[] CreatePayload(int bytes)
        {
            numberOfStrings = (int)(bytes / 8192) + 1;
            String[] load = new String[numberOfStrings];
            if (numberOfStrings > 1)
            {
                for (int i = 0; i < numberOfStrings - 1; i++)
                {
                    load[i] = new String('a', 8192);
                }
            }
            load[numberOfStrings - 1] = new String('a', bytes - 8192 * (numberOfStrings - 1));
            return load;
        }

        #endregion
    }
}
