using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;
using Messages.WS.Eventing;

namespace ReceivingServer
{
    
    [ServiceContract]
    interface IMessageUpdate
    {
        [OperationContract(Action = "http://www.example.org/test/MessageSending", IsOneWay = true)]
        void UpdateMessage(Message update);
    }

    public class MessageUpdateService : IMessageUpdate
    {
        public void UpdateMessage(Message update)
        {
            if (update != null)
            {
                ReceivingServer.GetInstance().UpdateServer(update.GetBody<MessageContents>());
            }
        }
        public delegate void MessageHandler(MessageTransferRequest req);
        public event MessageHandler MessageUpdated;
    }
}
