using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;

using RKiss.WSEventing;

namespace ReceivingServer
{
    public partial class Subscriber : Form
    {       
        private EventingProxy proxy;
        private MessageUpdateService mus;
        
        public Subscriber()
        {
            InitializeComponent();
            proxy = new EventingProxy();
            mus = new MessageUpdateService();
            mus.MessageUpdated += new MessageUpdateService.MessageHandler(mus_MessageUpdated);
        }

        void mus_MessageUpdated(Messages.WS.Eventing.MessageTransferRequest req)
        {
            PutText(req.message.ToString(), "Message updated"); 
        }

        //public static Subscriber GetInstance()
        //{
        //    if (instance == null)
        //    {
        //        instance = new Subscriber();
        //    }
        //    return instance;
        //}


        public void PutText(object text)
        {
            PutText(text, "");
        }

        public void PutText(object text, string caption)
        {
            txtOutput.AppendText("\n########################\n\n");
            if (!caption.Equals(String.Empty))
            {
                txtOutput.AppendText("-------- " + caption + " ---------\n");
            }
            txtOutput.AppendText(text.ToString());
            txtOutput.AppendText("\n########################\n\n");

        }

        private void cmdSub_Click(object sender, EventArgs e)
        {
            SubscribeResponse res = proxy.Subscribe();
            PutText(res.Body.ToString(), "Subscribe");
        }

        private void cmdUnsub_Click(object sender, EventArgs e)
        {
            UnsubscribeResponse res = proxy.Unsubscribe();
            PutText(res.ToString(), "Unsubscribe");
        }

        private void cmdRenew_Click(object sender, EventArgs e)
        {
            RenewResponse res = proxy.Renew();
            PutText(res.Body.ToString(), "Renew");
        }

        private void cmdGetStatus_Click(object sender, EventArgs e)
        {
            GetStatusResponse res = proxy.GetStatus();
            PutText(res.Body.ToString(), "Get status");

        }

    }
}