using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;

using Messages.WS.Eventing;
using SendingServer;

namespace SendingClient
{
    public partial class MessageSetup : Form
    {
        private SendingServer.SendingServer server = null;
        public MessageSetup()
        {
            InitializeComponent();
            server = new SendingServer.SendingServer();
        }

        private void cmdSend_Click(object sender, EventArgs e)
        {
            //PerformTest();
            PerformTestOpenConnection();
        }

        public MessageTransferRequest CreateRequest()
        {
            MessageTransferRequest request = new MessageTransferRequest(new MessageContents());
            int size = Int32.Parse(txtMsgSize.Text);
            request.message.Payload = MessageContents.CreatePayload(size);           
            request.message.DateTime = DateTime.Now;
            return request;
        }

        private void PerformTest()
        {            
            int numMsg = Int32.Parse(txtNumMsg.Text);
            lbStatus.Text = "Time started:";
            tbStartTick.Text = ""+DateTime.Now.Ticks;
            
            for (int i = 0; i < numMsg; i++)
            {
                server.SendMessage(CreateRequest());
            }            
        }

        private void PerformTestOpenConnection()
        {
            int numMsg = Int32.Parse(txtNumMsg.Text);
            lbStatus.Text = "Time started:";
            tbStartTick.Text = "" + DateTime.Now.Ticks;            
            for (int i = 0; i < numMsg; i++)
            {
                server.SendMessageOpenConnection(CreateRequest());
            }            
        }
    }
}