using System;
using System.Collections.Generic;
using System.Text;
using Messages.WS;


namespace Server.WS
{
    public class MessageServer : IMessageService
    {

        private HiPerfTimer timer = new HiPerfTimer();
        private List<MessageContents> m_messages = new List<MessageContents>();
        private static MessageServer m_instance;

        public delegate void MessageHandler(object source);
        public event MessageHandler MessageUpdated;

        public MessageServer()
        {
            Initialize(1, 36864); //antall meldinger, antall byte i meldingen. Konfig filen funker ikke, s konfigurer her! :)
        }

        public void Initialize(int msgs, int size)
        {
            int NUM_MSGS = msgs;
            int MSG_SIZE = size;
            for (int i = 0; i < NUM_MSGS; i++)
            {
                MessageContents mc = new MessageContents();
                mc.MessageId = i;
                mc.Payload = MessageContents.CreatePayload(MSG_SIZE);
                m_messages.Add(mc);
            }
        }

        public static MessageServer GetInstance()
        {
            if (m_instance == null)
            {
                m_instance = new MessageServer();
            }
            return m_instance;
        }

        //public MessageContents Messages
        //{
        //    get
        //    {
        //        return m_messages;
        //    }

        //    set
        //    {
        //        //m_messages.Add(value);
        //    }
        //}

        public bool SetMessage(MessageTransferRequest req)
        {
            MessageContents mc = req.Message;
            //mc.Time1 = DateTime.Now;
            m_messages.Add(mc);
            return true;
        }

        public MessageTransferResponse GetMessage(MessageTransferRequest req)
        {
            MessageTransferResponse res = new MessageTransferResponse();
            MessageContents mc = m_messages[req.message.MessageId];

            res.Message = mc;

            return res;
        }
    }
}
